//+------------------------------------------------------------------+
//|                                                           MA.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link "http://www.mql5.com"
#property version "1.00"
// https://www.mql5.com/en/code/1814 Modified

class MyClass {
public:
    int MA_Period ;
    int MA_Period1;
    int ma1Handle; // ????? ??????????  Moving Average
    int maHandle; // ????? ?????????? Moving Average
    double ma1Val[]; // ???????????? ??????? ??? ???????? ????????? ???????? Moving Average ??? ??????? ????
    double maVal[], jma1[], jma2[]; // ???????????? ?????? ??? ???????? ???????? ?????????? Moving Average ??? ??????? ????
    string symbol;
    MqlRates mrate[]; // ????? ????????? ????, ?????? ? ????? ??? ??????? ????
    double p_close; // ?????????? ??? ???????? ???????? close ????
  MqlTick latest_price;
    int jMAH1;
    int jMAH4;
    bool useEX;
  //  int jmaperiondh1 = 50;
    void init(int maP, int maPP, string sym, int jpetiod, ENUM_TIMEFRAMES time1, ENUM_TIMEFRAMES time2, bool useExtracondition)
    {
        MA_Period = maP;
        MA_Period1 = maPP;
        symbol = sym;
        ma1Handle = iMA(symbol, _Period, MA_Period1, 0, MODE_LWMA, PRICE_CLOSE);
        maHandle = iMA(symbol, _Period, MA_Period, 0, MODE_EMA, PRICE_CLOSE);
        jMAH1 = iMA(symbol, time1, jpetiod, 0, MODE_EMA, PRICE_CLOSE);
        jMAH4 = iMA(symbol, time2, jpetiod, 0, MODE_EMA, PRICE_CLOSE);
        useEX = useExtracondition;
        if (ma1Handle < 0 || maHandle < 0 || jMAH1 < 0 || jMAH4 < 0) {
            //Alert("?????? ??? ???????? ??????????? - ????? ??????: ", GetLastError(), "!!");
           // return (-1);
        }
    }

    void OnUeinit()
    {
        //--- ??????????? ?????? ???????????
        IndicatorRelease(ma1Handle);
        IndicatorRelease(maHandle);
        IndicatorRelease(jMAH1);
        IndicatorRelease(jMAH4);
    }

    bool buySellOrder(string buysell, double Lot, int EA_Magic, double STP, double TKP, string comment)
    {
        MqlTick latest_price; // ????? ?????????????? ??? ??????? ?????????
        MqlTradeRequest mrequest; // ????? ?????????????? ??? ??????? ???????? ????????
        MqlTradeResult mresult; // ????? ?????????????? ??? ????????? ??????????? ?????????? ???????? ????????
     
        ZeroMemory(mrequest);

        if (!SymbolInfoTick(symbol, latest_price)) {
            //Alert("?????? ????????? ????????? ????????? - ??????:", GetLastError(), "!!");
            return 0 ;
        }

        double ab = 0;
        if (buysell == "buy") {
            ab = latest_price.ask;
            mrequest.type = ORDER_TYPE_BUY; // ????? ?? ???????
        }
        else if (buysell == "sell") {
            ab = latest_price.bid;
            mrequest.type = ORDER_TYPE_SELL;
        }
        else {
            return false;
        }

        int digit = SymbolInfoInteger(symbol, SYMBOL_DIGITS);
        if (digit == 5 || digit == 3) {
            STP = STP * 10;
            TKP = TKP * 10;
        }
        double point = SymbolInfoDouble(symbol, SYMBOL_POINT);
        mrequest.action = TRADE_ACTION_DEAL; // ??????????? ??????????
        mrequest.price = NormalizeDouble(ab, digit); // ????????? ???? ask
    //    mrequest.sl = NormalizeDouble(ab - STP * point, digit); // Stop Loss
   //     mrequest.tp = NormalizeDouble(ab + TKP * point, digit); // Take Profit
        mrequest.symbol = symbol; // ??????
        mrequest.volume = Lot; // ?????????? ????? ??? ????????
        mrequest.magic = EA_Magic; // Magic Number
        mrequest.comment = comment;
        mrequest.type_filling = ORDER_FILLING_FOK; // ??? ?????????? ?????? - ??? ??? ??????
        mrequest.deviation = 100; // ??????????????? ?? ??????? ????
        OrderSend(mrequest, mresult) ;
        if (mresult.retcode == 10009 || mresult.retcode == 10008)
        {
            return true;
        }
        return false;
    }

    int process(bool isStrict)
    {
        int result = 0; //  0 nothing , 1 buy , 2 sell
       // ????? ?????????????? ??? ??????? ?????????
        ArraySetAsSeries(mrate, true);

        //--- ?????? ???????? ?????????? MA
        ArraySetAsSeries(ma1Val, true);

        //--- ?????? ???????? ?????????? MA-8
        ArraySetAsSeries(maVal, true);

        ArraySetAsSeries(jma1, true);
        ArraySetAsSeries(jma2, true);

        if (CopyRates(symbol, _Period, 0, 3, mrate) < 0) {
            //Alert("?????? ??????????? ???????????? ?????? - ??????:", GetLastError(), "!!");
            return 0;
        }

        if (!SymbolInfoTick(symbol, latest_price)) {
            //Alert("?????? ????????? ????????? ????????? - ??????:", GetLastError(), "!!");
            return 0;
        }
        if (!SymbolInfoTick(symbol, latest_price)) {
            //Alert("?????? ????????? ????????? ????????? - ??????:", GetLastError(), "!!");
            return 0;
        }

        //--- ???????? ???????????? ?????? ????????? 3-? ?????
        if (CopyRates(symbol, _Period, 0, 3, mrate) < 0) {
            //Alert("?????? ??????????? ???????????? ?????? - ??????:", GetLastError(), "!!");
            return 0;
        }

        //--- ???????? ???????? ??????????? ?? ???????????? ???????
        if (CopyBuffer(ma1Handle, 0, 0, 3, ma1Val) < 0) {
            //Alert("?????? ??????????? ??????? ?????????? Moving Average - ????? ??????:", GetLastError(), "!!");
            return 0;
        }
        if (CopyBuffer(maHandle, 0, 0, 3, maVal) < 0) {
            //Alert("?????? ??????????? ??????? ?????????? Moving Average - ????? ??????:", GetLastError());
            return 0;
        }

        if (CopyBuffer(jMAH1, 0, 0, 3, jma1) < 0) {
            //Alert("?????? ??????????? ??????? ?????????? Moving Average - ????? ??????:", GetLastError());
            return 0;
        }
        if (CopyBuffer(jMAH4, 0, 0, 3, jma2) < 0) {
            //Alert("?????? ??????????? ??????? ?????????? Moving Average - ????? ??????:", GetLastError());
            return 0;
        }

        p_close = mrate[1].close; // ???? ???????? ??????????? ????

        bool Buy_Condition_1 = (maVal[0] > maVal[1]) && (maVal[1] > maVal[2]); // MA-8 ??????
        bool Buy_Condition_2 = (ma1Val[0] > ma1Val[1]) && (ma1Val[1] > ma1Val[2]);
        bool Buy_Condition_3 = (p_close > maVal[1]); // ?????????? ???? ???????? ???? ?????????? ??????? MA-8
        bool Buy_Condition_4 = (maVal[0] > ma1Val[0]);

        //--- ???????? ??? ??????
        result = 0;
        if (Buy_Condition_1 && Buy_Condition_2) {
            if (Buy_Condition_3 && Buy_Condition_4) {
                result = 1;
            }
        }

        bool Sell_Condition_1 = (maVal[0] < maVal[1]) && (maVal[1] < maVal[2]); // MA-8 ??????
        bool Sell_Condition_2 = (p_close < maVal[1]); // ?????????? ???? ???????? ???? MA-8
        bool Sell_Condition_3 = (ma1Val[0] < ma1Val[1]) && (ma1Val[1] < ma1Val[2]); // ??????? ???????? ADX value ?????? ????????? (22)
        bool Sell_Condition_4 = (maVal[0] < ma1Val[0]); // -DI ??????, ??? +DI

        //--- ???????? ??? ??????
        if (Sell_Condition_1 && Sell_Condition_2) {
            if (Sell_Condition_3 && Sell_Condition_4) {
                if (result = 1) {
                    result = 0;
                }
                else {
                    result = -1;
                }
            }
        }

        if (useEX) {
            if (result == 1) {

                if (isStrict) {
                    if ((latest_price.ask < jma1[0] && latest_price.ask < jma2[0])) { // for complex change OR CONDITION PUT AND
                        result = 0;
                    }
                }
                else {
                    if ((latest_price.ask < jma1[0] || latest_price.ask < jma2[0])) { // for complex change OR CONDITION PUT AND
                        result = 0;
                    }
                }
            }
            else if (result == -1) {
                if (isStrict) {
                    if ((latest_price.bid > jma1[0] && latest_price.bid > jma2[0])) { // for complex change OR CONDITION PUT AND
                        result = 0;
                    }
                }
                else {
                    if ((latest_price.bid > jma1[0] || latest_price.bid > jma2[0])) { // for complex change OR CONDITION PUT AND
                        result = 0;
                    }
                }
            }
        }
        return result;
    }
};

#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh>
//--- input parameters
input int StopLoss = 100;
input int TakeProfit = 100;
input int MA_Period = 57;
input int MA_Period1 = 3;
input int EA_Magic = 12345;
input double Lot = 0.01;
input double AccountTP = 1; // Account Take Profit
input string sym1 = "EURUSD";
input string sym2 = "AUDUSD";
input bool isHaveSameTrandForBothSym = true;
input int jatinPeriod = 50;
input ENUM_TIMEFRAMES jatinMAPERIODH1 = PERIOD_H1; // JATIN MA PERIOD H1
input ENUM_TIMEFRAMES jatinMAPERIODH4 = PERIOD_H4; // JATIN MA PERIOD H4
input bool useExtracondition = false;
input bool isStrict = false;
input double Minimum_Spread_4_Open = 15; // minimum total spread
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
MyClass m1, m2;
string comment = "";
int STP , TKP ;
CPositionInfo m_Position; // structure for obtaining information of positions
CTrade trade;
int OnInit()
{
    comment = sym1 + sym2 + IntegerToString(EA_Magic);
    m1.init(MA_Period, MA_Period1, sym1, jatinPeriod,jatinMAPERIODH1, jatinMAPERIODH4, useExtracondition);
    m2.init(MA_Period, MA_Period1, sym2, jatinPeriod,jatinMAPERIODH1, jatinMAPERIODH4, useExtracondition);
    STP = StopLoss;
    TKP = TakeProfit;
    return (0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{

    m1.OnUeinit();
    m2.OnUeinit();
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
    if (isPairOpened(comment)) {
        //check for profit
        double profi = getProfitOfOrderPair(comment);
        if (profi >= AccountTP) {
            closeOrderByPair(comment);
        }
    }
    else {

        if (Minimum_Spread_4_Open != 0 && (getTotalSpread() > Minimum_Spread_4_Open))
            return;

        int s1 = m1.process(isStrict);
        int s2 = m2.process(isStrict);

        if (isStrict) {
            if (s1 == 0 || s2 == 0)
                return;

            if (isHaveSameTrandForBothSym) {
                if (s1 != s2)
                    return;

                if (s1 == s2) {
                    if (s1 == 1) {
                        m1.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                        m2.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                    }
                    else if (s1 == -1) {
                        m1.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                        m2.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                    }
                }
            }
            else {
                if (s1 == s2)
                    return;
                if (s1 != s2) {
                    if (s1 == 1 && s2 == -1) {
                        m1.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                        m2.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                    }
                    else if (s1 == -1 && s2 == 1) {
                        m1.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                        m2.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                    }
                }
            }
        }
        else {

            if (s1 == 0 && s2 == 0)
                return;

            if (isHaveSameTrandForBothSym) {

                if (s1 == 1 && s2 == -1)
                    return;
                if (s1 == -1 && s2 == 1)
                    return;

                if (s1 == 1 || s2 == 1) {
                    m1.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                    m2.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                }
                else if (s1 == -1 || s2 == -1) {
                    m1.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                    m2.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                }
            }
            else {

                if (s1 == 1 && s2 == 1)
                    return;
                if (s1 == -1 && s2 == -1)
                    return;

                if ((s1 == 1 || s2 == -1)) {
                    m1.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                    m2.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                }
                else if (s1 == -1 || s2 == 1) {
                    m1.buySellOrder("sell", Lot, EA_Magic, STP, TKP, comment);
                    m2.buySellOrder("buy", Lot, EA_Magic, STP, TKP, comment);
                }
            }
        }
    }
}

void closeOrderByPair(string pair)
{
    for (int i = PositionsTotal() - 1; i >= 0; i--) // returns the number of open positions
    {
        if (m_Position.SelectByIndex(i)) {
            if (m_Position.Comment() == pair) {
                if (!trade.PositionClose(PositionGetTicket(i))) {
                    Print(PositionGetSymbol(i), "PositionClose() method failed. Return code=", trade.ResultRetcode(), ". Code description: ", trade.ResultRetcodeDescription()); //--- failure message
                }
            }
        }
    }
}
bool isPairOpened(string pair)
{
    bool isPairOpen = false;
    for (int i = PositionsTotal() - 1; i >= 0; i--) // returns the number of open positions
    {
        if (m_Position.SelectByIndex(i)) {
            if (m_Position.Comment() == pair) {
                isPairOpen = true;
                return isPairOpen;
            }
        }
    }
    return isPairOpen;
}

double getProfitOfOrderPair(string pair)
{
    double pProfit = 0.0;
    for (int i = PositionsTotal() - 1; i >= 0; i--) // returns the number of open positions
    {
        if (m_Position.SelectByIndex(i)) {
            if (m_Position.Comment() == pair) {
                pProfit = pProfit + m_Position.Profit() + m_Position.Swap() + m_Position.Commission();
            }
        }
    }
    return pProfit;
}

double getTotalSpread()
{
    double d = SymbolInfoDouble(sym1, SYMBOL_ASK) - SymbolInfoDouble(sym1, SYMBOL_BID);
    double spread = SymbolInfoDouble(sym2, SYMBOL_ASK) - SymbolInfoDouble(sym2, SYMBOL_BID);
    return d + spread;
}
//+------------------------------------------------------------------+
